diff --git a/gcc/fortran/trans-openmp.cc b/gcc/fortran/trans-openmp.cc
index e55c8292d05..96e91a3bc50 100644
--- a/gcc/fortran/trans-openmp.cc
+++ b/gcc/fortran/trans-openmp.cc
@@ -1611,7 +1611,7 @@ gfc_omp_finish_clause (tree c, gimple_seq *pre_p, bool openacc)
   tree c2 = NULL_TREE, c3 = NULL_TREE, c4 = NULL_TREE;
   tree present = gfc_omp_check_optional_argument (decl, true);
   tree orig_decl = NULL_TREE;
-  if (DECL_P (decl) && POINTER_TYPE_P (TREE_TYPE (decl)))
+  if (POINTER_TYPE_P (TREE_TYPE (decl)))
     {
       if (!gfc_omp_privatize_by_reference (decl)
 	  && !GFC_DECL_GET_SCALAR_POINTER (decl)
diff --git a/gcc/gimplify.cc b/gcc/gimplify.cc
index 3729b986801..80f1f3a657f 100644
--- a/gcc/gimplify.cc
+++ b/gcc/gimplify.cc
@@ -227,7 +227,6 @@ struct oacc_array_mapping_info
   tree mapping;
   tree pset;
   tree pointer;
-  tree ref;
 };
 
 struct gimplify_omp_ctx
@@ -11248,9 +11247,6 @@ gimplify_scan_omp_clauses (tree *list_p, gimple_seq *pre_p,
 		  }
 		if (base_ptr
 		    && OMP_CLAUSE_CODE (base_ptr) == OMP_CLAUSE_MAP
-		    && !(OMP_CLAUSE_CODE (c) == OMP_CLAUSE_MAP
-			 && (OMP_CLAUSE_MAP_KIND (c) == GOMP_MAP_ALLOC
-			     || OMP_CLAUSE_MAP_KIND (c) == GOMP_MAP_POINTER))
 		    && OMP_CLAUSE_MAP_KIND (c) != GOMP_MAP_TO_PSET
 		    && ((OMP_CLAUSE_MAP_KIND (base_ptr)
 			 == GOMP_MAP_FIRSTPRIVATE_POINTER)
@@ -11269,19 +11265,6 @@ gimplify_scan_omp_clauses (tree *list_p, gimple_seq *pre_p,
 		    ai.mapping = unshare_expr (c);
 		    ai.pset = pset ? unshare_expr (pset) : NULL;
 		    ai.pointer = unshare_expr (base_ptr);
-		    ai.ref = NULL_TREE;
-		    if (TREE_CODE (base_addr) == INDIRECT_REF
-			&& (TREE_CODE (TREE_TYPE (TREE_OPERAND (base_addr, 0)))
-			    == REFERENCE_TYPE))
-		      {
-			base_addr = TREE_OPERAND (base_addr, 0);
-			tree ref_clause = OMP_CLAUSE_CHAIN (base_ptr);
-			gcc_assert ((OMP_CLAUSE_CODE (ref_clause)
-				     == OMP_CLAUSE_MAP)
-				    && (OMP_CLAUSE_MAP_KIND (ref_clause)
-				        == GOMP_MAP_POINTER));
-			ai.ref = unshare_expr (ref_clause);
-		      }
 		    ctx->decl_data_clause->put (base_addr, ai);
 		  }
 		if (TREE_CODE (TREE_TYPE (decl)) != ARRAY_TYPE)
@@ -12464,15 +12447,11 @@ gomp_oacc_needs_data_present (tree decl)
       && gimplify_omp_ctxp->region_type != ORT_ACC_KERNELS)
     return NULL;
 
-  tree type = TREE_TYPE (decl);
-  if (TREE_CODE (type) == REFERENCE_TYPE)
-    type = TREE_TYPE (type);
-
-  if (TREE_CODE (type) != ARRAY_TYPE
-      && TREE_CODE (type) != POINTER_TYPE
-      && TREE_CODE (type) != RECORD_TYPE
-      && (TREE_CODE (type) != POINTER_TYPE
-	  || TREE_CODE (TREE_TYPE (type)) != ARRAY_TYPE))
+  if (TREE_CODE (TREE_TYPE (decl)) != ARRAY_TYPE
+      && TREE_CODE (TREE_TYPE (decl)) != POINTER_TYPE
+      && TREE_CODE (TREE_TYPE (decl)) != RECORD_TYPE
+      && (TREE_CODE (TREE_TYPE (decl)) != POINTER_TYPE
+	  || TREE_CODE (TREE_TYPE (TREE_TYPE (decl))) != ARRAY_TYPE))
     return NULL;
 
   decl = get_base_address (decl);
@@ -12626,12 +12605,6 @@ gimplify_adjust_omp_clauses_1 (splay_tree_node n, void *data)
     {
       tree mapping = array_info->mapping;
       tree pointer = array_info->pointer;
-      gomp_map_kind presence_kind = GOMP_MAP_FORCE_PRESENT;
-      bool no_alloc = (OMP_CLAUSE_CODE (mapping) == OMP_CLAUSE_MAP
-		       && OMP_CLAUSE_MAP_KIND (mapping) == GOMP_MAP_IF_PRESENT);
-
-      if (no_alloc || omp_check_optional_argument (decl, false))
-        presence_kind = GOMP_MAP_IF_PRESENT;
 
       if (code == OMP_CLAUSE_FIRSTPRIVATE)
 	/* Oops, we have the wrong type of clause.  Rebuild it.  */
@@ -12639,15 +12612,14 @@ gimplify_adjust_omp_clauses_1 (splay_tree_node n, void *data)
 				   OMP_CLAUSE_MAP);
 
       OMP_CLAUSE_DECL (clause) = unshare_expr (OMP_CLAUSE_DECL (mapping));
-      OMP_CLAUSE_SET_MAP_KIND (clause, presence_kind);
+      OMP_CLAUSE_SET_MAP_KIND (clause, GOMP_MAP_FORCE_PRESENT);
       OMP_CLAUSE_SIZE (clause) = unshare_expr (OMP_CLAUSE_SIZE (mapping));
 
       /* Create a new data clause for the firstprivate pointer.  */
       tree nc = build_omp_clause (OMP_CLAUSE_LOCATION (clause),
 				  OMP_CLAUSE_MAP);
       OMP_CLAUSE_DECL (nc) = unshare_expr (OMP_CLAUSE_DECL (pointer));
-      OMP_CLAUSE_SET_MAP_KIND (nc, no_alloc ? GOMP_MAP_FIRSTPRIVATE_POINTER
-					    : GOMP_MAP_POINTER);
+      OMP_CLAUSE_SET_MAP_KIND (nc, GOMP_MAP_POINTER);
 
       /* For GOMP_MAP_FIRSTPRIVATE_POINTER, this is a bias, not a size.  */
       OMP_CLAUSE_SIZE (nc) = unshare_expr (OMP_CLAUSE_SIZE (pointer));
@@ -12677,19 +12649,6 @@ gimplify_adjust_omp_clauses_1 (splay_tree_node n, void *data)
 
       OMP_CLAUSE_CHAIN (nc) = OMP_CLAUSE_CHAIN (clause);
       OMP_CLAUSE_CHAIN (clause) = psetc ? psetc : nc;
-
-      if (array_info->ref)
-	{
-	  tree refc = build_omp_clause (OMP_CLAUSE_LOCATION (clause),
-					OMP_CLAUSE_MAP);
-	  OMP_CLAUSE_DECL (refc)
-	    = unshare_expr (OMP_CLAUSE_DECL (array_info->ref));
-	  OMP_CLAUSE_SIZE (refc)
-	    = unshare_expr (OMP_CLAUSE_SIZE (array_info->ref));
-	  OMP_CLAUSE_SET_MAP_KIND (refc, GOMP_MAP_POINTER);
-	  OMP_CLAUSE_CHAIN (refc) = OMP_CLAUSE_CHAIN (nc);
-	  OMP_CLAUSE_CHAIN (nc) = refc;
-	}
     }
   else if (code == OMP_CLAUSE_FIRSTPRIVATE && (flags & GOVD_EXPLICIT) == 0)
     OMP_CLAUSE_FIRSTPRIVATE_IMPLICIT (clause) = 1;